package com.qihoo360.mobilesafe.reward.container

import android.graphics.Color
import android.graphics.drawable.ColorDrawable
import android.widget.ImageView
import com.nostra13.universalimageloader.core.DisplayImageOptions
import com.nostra13.universalimageloader.core.process.BitmapProcessor
import com.qihoo360.apullsdk.support.imageconfig.ImageDownloaderConfig
import com.qihoo360.apullsdk.support.imageconfig.ImageLoaderWrapper
import com.qihoo360.apullsdk.utils.BitmapUtil
import com.qihoo360.mobilesafe.reward.R



fun ImageView.displayImage(url :String?) {
    url?.apply {
        val postBitmapProcessor = BitmapProcessor { bitmap ->
            BitmapUtil.cricleBitmap(bitmap, 36,
                    2, Color.parseColor("#fee5c4"))
        }

        val defaultIcon = context.resources.getDrawable(R.drawable.app_default_icon)
        val mDefaultIconOptions = DisplayImageOptions.Builder()
                .cloneFrom(ImageDownloaderConfig.OPTIONS_DEFAULT)
                .showImageOnLoading(defaultIcon)
                .showImageForEmptyUri(defaultIcon)
                .showImageOnFail(defaultIcon)
                .postProcessor(postBitmapProcessor).build()
        ImageLoaderWrapper.getInstance().displayImage(url, this@displayImage,
                mDefaultIconOptions)
    } ?: run {
        val defaultColor = -0x66171718
        val defaultIcon = ColorDrawable(defaultColor)
       setImageDrawable(defaultIcon)
    }
}
