package com.qihoo360.mobilesafe.reward.data

import com.qihoo360.mobilesafe.extension.tryCatch
import com.qihoo360.mobilesafe.reward.data.IntentConstant.Companion.BACKGROUND
import com.qihoo360.mobilesafe.reward.data.IntentConstant.Companion.EXTRA_KEY_PAGE_ID
import com.qihoo360.mobilesafe.reward.data.IntentConstant.Companion.EXTRA_KEY_SUB_PAGE_ID
import com.qihoo360.mobilesafe.reward.data.IntentConstant.Companion.POOL
import com.qihoo360.mobilesafe.reward.data.IntentConstant.Companion.PROMOTION_ID
import com.qihoo360.mobilesafe.reward.data.IntentConstant.Companion.SHARE_DESC_KEY
import com.qihoo360.mobilesafe.reward.data.IntentConstant.Companion.SHARE_TITLE_KEY
import com.qihoo360.mobilesafe.reward.data.IntentConstant.Companion.TAG
import com.qihoo360.mobilesafe.reward.data.IntentConstant.Companion.TITLE
import com.qihoo360.mobilesafe.reward.data.IntentConstant.Companion.URL
import com.qihoo360.mobilesafe.reward.data.IntentConstant.Companion.WB_IMG
import com.qihoo360.mobilesafe.reward.data.IntentConstant.Companion.WX_IMG
import com.qihoo360.mobilesafe.support.log.Logger
import org.json.JSONObject

class FromIntentData {

    var mScene: Int = 0

    var mSubScene: Int = 0

    var mReferScene: Int = 0

    var mReferSubScene: Int = 0

    var mTitle: String = ""

    var mUrl: String = ""

    var mPool: String = ""

    var mPromotionId: String = ""

    var mBackground: String = ""

    var mWxImgUrl: String = ""

    var mWbImgUrl: String = ""

    var mShareTitle: String = ""

    var mShareDesc: String = ""

    var mBatteryQuantity : Int = 0

    var wxImgPath: String? = ""

    var wbImgPath: String? = ""
}

class IntentConstant {

    companion object {
        const val TAG = "FromIntentData"

        const val EXTRA_KEY_PAGE_ID = "page_id"

        const val EXTRA_KEY_SUB_PAGE_ID = "sub_page_id"

        const val EXTRA_KEY_REFER_PAGE_ID = "refer_page_id"

        const val EXTRA_KEY_REFER_SUB_PAGE_ID = "refer_sub_page_id"

        const val EXTRA_JSON_INFO = "json_info"

        const val TITLE = "title"

        const val URL = "url"

        const val POOL = "pool"

        const val PROMOTION_ID = "promotionId"

        const val BACKGROUND = "background"

        const val WX_IMG = "wx_img"

        const val WB_IMG = "wb_img"

        const val SHARE_TITLE_KEY = "share_title_key"

        const val SHARE_DESC_KEY = "share_desc_key"
    }
}

fun FromIntentData.applyData(string: String?): FromIntentData {
    tryCatch ({
        Logger.handleException(it)
        Logger.v("FromIntentData", "initIntentData FromIntentData.applydata exception")
    }){
        string?.apply {
            Logger.v(TAG, "initIntentData json_info rawStr =  : $this")
            val json = JSONObject(this)
            mScene= json.optInt(EXTRA_KEY_PAGE_ID)
            mSubScene = json.optInt(EXTRA_KEY_SUB_PAGE_ID)
            mTitle = json.optString(TITLE)
            mUrl = json.optString(URL)
            mPool = json.optString(POOL)
            mPromotionId = json.optString(PROMOTION_ID)

            mBackground = json.optString(BACKGROUND)
            mWxImgUrl = json.optString(WX_IMG)
            mWbImgUrl = json.optString(WB_IMG)
            mShareTitle = json.optString(SHARE_TITLE_KEY)
            mShareDesc = json.optString(SHARE_DESC_KEY)
            Logger.v(TAG,"initIntentData server params:   mScene = $mScene,mSubScene = $mSubScene,mTitle=$mTitle,mUrl=$mUrl," +
                    "mUrl=$mUrl,mPromotionId=$mPromotionId,mBackground=$mBackground,mWxImgUrl=$mWxImgUrl," +
                    "mWbImgUrl = $mWbImgUrl,mShareTitle=$mShareTitle,mShareDesc=$mShareDesc")
        }
    }

    return this
}

