package com.qihoo360.mobilesafe.reward.presenter

import android.annotation.SuppressLint
import android.app.Activity
import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.text.TextUtils
import com.qihoo360.apullsdk.apull.ApullConst
import com.qihoo360.apullsdk.apull.protocol.ApullReportManager
import com.qihoo360.apullsdk.apull.protocol.model.ApullTemplateBase
import com.qihoo360.apullsdk.apull.protocol.model.impl.TemplateApullApp
import com.qihoo360.apullsdk.apull.protocol.model.impl.TemplateApullMv
import com.qihoo360.apullsdk.apull.protocol.model.impl.TemplateApullTouTiao
import com.qihoo360.apullsdk.apull.protocol.model.impl.TemplateGdt
import com.qihoo360.apullsdk.apull.protocol.request.ApullRequestBase
import com.qihoo360.apullsdk.apull.view.ApullContainerBase
import com.qihoo360.apullsdk.utils.PackageUtil
import com.qihoo360.mobilesafe.authguide.service.AuthConst
import com.qihoo360.mobilesafe.extension.toast
import com.qihoo360.mobilesafe.extension.tryCatch
import com.qihoo360.mobilesafe.reward.R
import com.qihoo360.mobilesafe.reward.RewardConstant
import com.qihoo360.mobilesafe.reward.RewardConstant.Companion.PAGE_REWARD_HOUR_SUBSCENE_1
import com.qihoo360.mobilesafe.reward.RewardConstant.Companion.PAGE_REWARD_HOUR_SUBSCENE_2
import com.qihoo360.mobilesafe.reward.RewardConstant.Companion.PAGE_REWARD_HOUR_SUBSCENE_3
import com.qihoo360.mobilesafe.reward.RewardConstant.Companion.PAGE_REWARD_HOUR_SUBSCENE_4
import com.qihoo360.mobilesafe.reward.RewardConstant.Companion.PAGE_REWARD_SCENE
import com.qihoo360.mobilesafe.reward.RewardConstant.Companion.PAGE_REWARD_SUBSCENE_0
import com.qihoo360.mobilesafe.reward.RewardConstant.Companion.PAGE_REWARD_TWICE_DIALOG_SUBSCENE
import com.qihoo360.mobilesafe.reward.RewardConstant.Companion.REWARD_DEBUG
import com.qihoo360.mobilesafe.reward.container.RewardContainer
import com.qihoo360.mobilesafe.reward.container.app.*
import com.qihoo360.mobilesafe.reward.container.gdt.ContainerGdt2105
import com.qihoo360.mobilesafe.reward.container.mv.ContainerApullMv531
import com.qihoo360.mobilesafe.reward.container.mv.ContainerApullMv532
import com.qihoo360.mobilesafe.reward.container.toutiao.ContainerApullTouTiao2606
import com.qihoo360.mobilesafe.reward.data.ApullItemWrapper
import com.qihoo360.mobilesafe.reward.data.FromIntentData
import com.qihoo360.mobilesafe.reward.data.RewardRecordManager
import com.qihoo360.mobilesafe.reward.data.RewardUtils
import com.qihoo360.mobilesafe.reward.data.env.FakeRewardData
import com.qihoo360.mobilesafe.reward.presenter.base.BasePresenter
import com.qihoo360.mobilesafe.reward.presenter.view.RewardView
import com.qihoo360.mobilesafe.reward.respository.ApullRewardManager
import com.qihoo360.mobilesafe.reward.respository.RewardCommitResponse
import com.qihoo360.mobilesafe.reward.respository.RewardTryResponse
import com.qihoo360.mobilesafe.reward.ui.page.RaffleActivity
import com.qihoo360.mobilesafe.reward.ui.page.RaffleHourActivity
import com.qihoo360.mobilesafe.reward.ui.page.RaffleThemeActivity
import com.qihoo360.mobilesafe.reward.ui.page.dialog.RewardAuthGuideDialog
import com.qihoo360.mobilesafe.reward.ui.page.dialog.RewardDownloadDialog.Companion.DONT_HAS_CHANCE
import com.qihoo360.mobilesafe.reward.ui.page.dialog.RewardDownloadDialog.Companion.SHARE_MORE_CHANCE
import com.qihoo360.mobilesafe.reward.ui.page.dialog.RewardDownloadDialog.Companion.TIMEOUT
import com.qihoo360.mobilesafe.reward.ui.page.dialog.RewardNewTwiceDialog
import com.qihoo360.mobilesafe.reward.utils.RewardCmdHandle
import com.qihoo360.mobilesafe.reward.utils.TryResponseListenerManager
import com.qihoo360.mobilesafe.support.log.Logger
import com.qihoo360.mobilesafe.user.LoginProxy
import com.qihoo360.newssdk.control.policy.ApullRequestListener
import com.qihoo360.newssdk.export.LoginInterface
import com.qihoo360.newssdk.export.request.RequestExport
import com.qihoo360.newssdk.protocol.model.TemplateBase

class RewardPresenter : BasePresenter<RewardView>(),RewardRecordManager.Listener{

    companion object {
        var DEBUG: Boolean = Logger.bDebug()
        const val TAG = "RewardPresenter"
    }
    private lateinit var mContext: Activity

    private var mTwiceRewardContainer :RewardContainer? = null

    private lateinit var mRewardViewModel: RewardViewModel

    private lateinit var mRewardRecordManager: RewardRecordManager

    private lateinit var mRewardMainHandler: RewardMainHandler

    private var mIsTrying = false

    private var mIsDialogShow = false

    private var mDialogFromRecord = false

    private var mLastPackageName: String? = ""
    /**
     * 用户信息
     */
    private var mUserInfoBundle: Bundle? = null


    fun init(activity: Activity) {
        mContext = activity
        mRewardViewModel = RewardViewModel()
        mRewardRecordManager = RewardRecordManager(this, mContext, mContext)
        mRewardMainHandler = RewardMainHandler(this)
    }

    fun requestRewardAd(mContext: Context, mScene: Int, mSubScene: Int,
                        mReferScene: Int, mReferSubScene: Int) {
        Logger.d(TAG,"requestRewardAd")
        mRewardMainHandler.postRewardRequestTimeOut()
        RequestExport.requestApull(mContext,mScene, mSubScene,mReferScene,mReferSubScene, 0,"youlike",
                null, object : ApullRequestListener() {
            override fun onApullResponse(apullrequestbase: ApullRequestBase?, list: MutableList<TemplateBase>?,
                                         request_status: Int) {
                mRewardMainHandler.postRewardResponseSuccess(list,mScene,mSubScene)
            }
        })

        if (mScene == PAGE_REWARD_SCENE && mSubScene == PAGE_REWARD_SUBSCENE_0) {
            if(canShowTwiceDialog()) {
                requestRewardTwiceAd(mContext, PAGE_REWARD_SCENE, PAGE_REWARD_TWICE_DIALOG_SUBSCENE,
                        mReferScene, mReferSubScene)
            }
        }
    }

    fun handleRewardSuccess(list: MutableList<TemplateBase>?,scene: Int,subScene: Int){
        list?.apply {
            Logger.d(TAG,"handleRewardSuccess size:${list.size}")
            if(size > 0) {
                handleRewardResponse(this,scene,subScene)
            }else{
                handleRewardEmpty()
            }
        } ?: kotlin.run {
            handleRewardEmpty()
        }
    }

    fun handleRewardTimeout(){
        Logger.d(TAG,"handleRewardTimeout timeOut")
        mView?.onRewardTimeOut()
    }

    fun handleRewardEmpty(){
        Logger.d(TAG,"handleRewardEmpty empty")
        mView?.onRewardResponse(null,-1)
    }

    private fun requestRewardTwiceAd(mContext: Context, mScene: Int, mSubScene: Int, mReferScene: Int, mReferSubScene: Int) {
        Logger.d(TAG,"requestRewardTwiceAd")
        RequestExport.requestApull(mContext,mScene, mSubScene, mReferScene,mReferSubScene,0,"youlike",
                null, object : ApullRequestListener() {
            override fun onApullResponse(apullrequestbase: ApullRequestBase?, list: MutableList<TemplateBase?>?, request_status: Int) {
                Logger.d(TAG,"requestRewardTwiceAd")
                mRewardMainHandler.post {
                    list?.apply {
                        if(list.size > 0) {
                            mRewardViewModel.cacheTwiceTemplates(list)
                        }
                    }
                }
            }
        })
    }

    /***
     * 展示常规红包和专场红包模版
     * @param list 红包模版
     * @param pageCount:每页显示红包个数
     */
    private fun createRewardContainerAndShow(list: MutableList<TemplateBase>,pageCount:Int){
        val pairs = mutableListOf<Pair<ApullTemplateBase?, ApullContainerBase?>>()
        list.filter {
            it.apullTemplateBase != null
        }.map {
            templateBase ->templateBase.apullTemplateBase
        }.filter {
            it != null
        }.forEach { template ->
            if(template is TemplateGdt){
                val gdtItem = template.defaultItem
                if(gdtItem?.isApp == false){
                    //TODO 广点通非下载类只打点不展示
                    tryCatch {
                        Logger.d(TAG, "createRewardContainerAndShow gdt openType : ${template.toJson()}")
                    }
                    ApullReportManager.reportApullPvAll(mContext,template)
                    return@forEach
                }
            }

            if(template is TemplateApullTouTiao){
                val touTiaoItem = template.defaultItem
                if(touTiaoItem?.interaction_type != 4) {
                    tryCatch {
                        Logger.d(TAG,"createRewardContainerAndShow toutiao openType: ${template.toJson()}")
                    }
                    //TODO 过滤头条非下载类
                    return@forEach
                }
            }

            /**
             * 打开类的，无deeplink时，按打开类跳转到h5算，有deeplink无url未安装时过滤掉
             */
            if(template is TemplateApullMv) {
                val mvItem = template.defaultItem
                if (!TextUtils.isEmpty(mvItem?.deeplink_pkgname)) {
                    if (!PackageUtil.isPkgInstalled(mContext, mvItem?.deeplink_pkgname)
                            && TextUtils.isEmpty(mvItem?.interaction_object?.url)
                            && !TextUtils.isEmpty(mvItem?.interaction_object?.deeplink)) {
                        tryCatch {
                            Logger.d(TAG,"createRewardContainerAndShow mv openType: ${template.toJson()}")
                        }
                        return@forEach
                    }
                }

            }

            val container = buildSingleRewardContainer(mContext, template)
            container?.let {
                val pair = Pair(template, it)
                mRewardViewModel.cacheRewardTemplate(template)
                pairs.add(pair)
            }
        }
        if(pairs.size > 0){
            Logger.d(TAG,"createRewardContainerAndShow show size : ${pairs.size}")

            val mPageSize = if (pairs.size % pageCount  != 0) {
                pairs.size / pageCount + 1
            } else {
                pairs.size / pageCount
            }
            val mRewardContainer = RewardContainer(this@RewardPresenter.mContext, pairs, pageCount)
            mView?.onRewardResponse(mRewardContainer, mPageSize)
        }else{
            handleRewardEmpty()
        }
    }

    private fun handleRewardResponse(list: MutableList<TemplateBase>,scene: Int ,subScene:Int) {
        tryCatch({
            Logger.v(TAG,"handleRewardResponse :"+it.message)
            Logger.handleException(it)
        }){
            if(scene == RewardConstant.PAGE_REWARD_SCENE) {
                when (mContext) {
                    is RaffleActivity -> {
                        createRewardContainerAndShow(list, 3)
                    }
                    is RaffleThemeActivity -> {
                        createRewardContainerAndShow(list, 1)
                    }
                    is RaffleHourActivity -> {
                        when (subScene) {
                            PAGE_REWARD_HOUR_SUBSCENE_1,
                            PAGE_REWARD_HOUR_SUBSCENE_2,
                            PAGE_REWARD_HOUR_SUBSCENE_3,
                            PAGE_REWARD_HOUR_SUBSCENE_4 -> {
                                val templateApullApp: TemplateApullApp? =
                                        list.filter {
                                            it.apullTemplateBase != null
                                        }.map {
                                            it.apullTemplateBase
                                        }.filter {
                                            it != null
                                        }.first { it is TemplateApullApp } as? TemplateApullApp

                                templateApullApp?.apply {
                                    mRewardViewModel.cacheRewardTemplate(this)
                                    mRewardViewModel.cacheHourTemplate(scene, subScene, this)
                                    val container = buildSingleRewardContainer(this@RewardPresenter.mContext, templateApullApp)
                                    mView?.onRewardResponse(container, 1)
                                } ?: kotlin.run {
                                    handleRewardEmpty()
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    fun buildSingleRewardContainer(mContext: Context?, template: ApullTemplateBase?): ApullContainerBase? {
        var container: ApullContainerBase? = null
        mContext?.let {
            container = when (template?.type) {
                80 -> ContainerApullApp80(it, template)
                531 -> ContainerApullMv531(it, template)
                2105 -> ContainerGdt2105(it, template)
                532 -> ContainerApullMv532(it,template)
                59 ->ContainerApullApp59(it,template)
                37->ContainerApullApp37(it,template)
                67->ContainerApullApp67(it,template)
                2606 -> ContainerApullTouTiao2606(it,template)
                else -> {
                    null
                }
            }
        }
        return container
    }


    fun handleWorkingPackage(key: String?) {
        key?.run {
            mRewardViewModel.cacheWorkingTemplate(mRewardViewModel.getRewardTemplate(this))
        }
    }

    fun handlePackageInstalled(key: String?,mData: FromIntentData,rewardType:Int = RewardUtils.REWARD_TYPE_APP) {
        if (!key.isNullOrEmpty()) {
            Logger.d(TAG,"handlePackageInstalled")
            val templateBase = mRewardViewModel.getWorkingTemplate(key)
            if(templateBase?.subscene == 8){//返回弹窗下载不参与领红包
                return
            }
            templateBase?.let {
                val rewardBasicInfo = RewardUtils.RewardBasicInfo()
                rewardBasicInfo.pool = mData.mPool
                rewardBasicInfo.promotionId = mData.mPromotionId
                rewardBasicInfo.wxImgPath = mData.wxImgPath
                rewardBasicInfo.wbImgPath = mData.wbImgPath
                rewardBasicInfo.shareTitle = mData.mShareTitle
                rewardBasicInfo.shareDesc = mData.mShareDesc

                val rewardInfo = RewardUtils.RewardInfo()
                rewardInfo.shareInfo = ""
                val share = RewardUtils.getSharedInfo(mContext)
                if (share == 1) {
                    rewardInfo.shareInfo = "true"
                }
                rewardInfo.rewardBasicInfo = rewardBasicInfo
                rewardInfo.apullTemplate = it
                rewardInfo.batteryQuantity = mData.mBatteryQuantity;
                rewardInfo.apullAdItem = ApullItemWrapper(it)
                rewardInfo.rewardType = rewardType
                startRewardOpened(rewardInfo)
            }
        }
    }

    private fun startRewardOpened(rewardInfo: RewardUtils.RewardInfo) {
        val cacheRewardInfo = mRewardViewModel.getRewardInfo(rewardInfo.apullAdItem?.uniqueId)

        cacheRewardInfo?.apply {
            tryCatch {
                if ((rewardInfo.rewardType == RewardUtils.REWARD_TYPE_OPEN)) {
                    //TODO gzw
                    /*|| rewardInfo?.rewardType == RewardUtils.REWARD_TYPE_OPEN_DEEP_LINK)*/
                    var flag = false
                    Logger.d(TAG,"startRewardOpened hasRewardCache")
                    /*if(tryResponse == null &&  mRewardViewModel.getTryResponse(rewardInfo.apullAdItem?.uniqueId) == null){
                        beginRewardTry(rewardInfo)
                    }else */if(hasRewardOpenChance()) {
                        if (rewardInfo.rewardType == RewardUtils.REWARD_TYPE_OPEN) {
                            Logger.d(TAG, "startRewardOpened hasRewardOpenTypeCache")
                            TryResponseListenerManager.notifyOnTryResponseChanged(this)
                        }
                        flag = true

                    }

                    if(!flag) {
                        mContext.toast(mContext.getString(R.string.hongbao_tip_try_again))
                    }
                    return@apply
                }
            }
        } ?: run {
            beginRewardTry(rewardInfo)
        }
    }

    private fun beginRewardTry(rewardInfo: RewardUtils.RewardInfo) {
        tryCatch {
            if(!mIsTrying) {
                Logger.d(TAG,"beginRewardTry")
                if (rewardInfo.apullAdItem == null || mRewardViewModel.getTryResponse(rewardInfo.apullAdItem?.uniqueId) != null) {
                    Logger.d(TAG,"beginRewardTry rewardInfo?.apullAdItem empty")
                    mRewardMainHandler.postNoRewardChance(rewardInfo,3000)
                    return
                }
                startRewardTry(rewardInfo)

            }else{
                Logger.d(TAG,"beginRewardTry one")
                //缓存处理
            }
        }
    }

    private fun startRewardTry(rewardInfo: RewardUtils.RewardInfo) {
        Logger.d(TAG,"startRewardTry")

        mIsTrying = true
        mIsDialogShow = true
        refreshLoginInfo()

        rewardInfo.qid = mUserInfoBundle?.getString(LoginInterface.KEY_LOGININFO_QID)
        mRewardViewModel.cacheRewardInfo(rewardInfo.apullAdItem.uniqueId,rewardInfo)

        ApullRewardManager.getInstance().query(mContext, rewardInfo, mContext, rewardInfo.batteryQuantity,
                rewardInfo.qid, mUserInfoBundle?.getString(LoginInterface.KEY_LOGININFO_Q),
                mUserInfoBundle?.getString(LoginInterface.KEY_LOGININFO_T), object : ApullRewardManager.Listener {

            override fun onCommitResponse(response: RewardCommitResponse?) {
            }

            override fun onTryResponse(response: RewardTryResponse?) {
                Logger.d(TAG, "startRewardTry onTryResponse")
                mRewardMainHandler.postRewardTrySuccess(response,rewardInfo)
            }

        })

        mRewardMainHandler.postRewardTryTimeout(rewardInfo)
    }

    fun handleTryResult(rewardInfo: RewardUtils.RewardInfo?) {
        Logger.d(TAG, "handleTryResult")

        if(REWARD_DEBUG){
            FakeRewardData.fakeTryResponse0(rewardInfo?.tryResponse)
        }

        mIsTrying = false

        if (rewardInfo?.tryResponse == null) {
            Logger.d(TAG, "handleTryResult rewardInfo?.tryResponse empty")
            when (rewardInfo?.rewardType) {
                RewardUtils.REWARD_TYPE_APP -> {
                    mRewardMainHandler.postNoRewardChance(rewardInfo, 0)
                }
                RewardUtils.REWARD_TYPE_OPEN -> {
                    TryResponseListenerManager.notifyOnTryResponseChanged(null)
                }
            }
            mIsTrying = false
            return
        }

        tryCatch {
            Logger.d(TAG,"handleTryResult : errno:${rewardInfo.tryResponse.errno}  " +
                    "chances:${rewardInfo.tryResponse.chances}  " +
                    "result:${rewardInfo.tryResponse.result}  " +
                    "share:${rewardInfo.tryResponse.share}  " +
                    "rewardType:${rewardInfo.tryResponse.rewardType}  " +
                    "token:${rewardInfo.tryResponse.token}  ")
        }

        rewardInfo.tryResponse.apply {
            mRewardViewModel.cacheRewardInfo(uniqueId, rewardInfo)
            mRewardViewModel.cacheTryResponse(uniqueId, this)
            if(!mDialogFromRecord) {
                mView?.refreshTryResultStatus(rewardInfo)
            }
        }.apply {
            if(hasRewardOpenChance()){
                Logger.d(TAG, "handleTryResult hasRewardOpenChance")
                mRewardRecordManager.saveTryRecord(rewardInfo)

                if (mDialogFromRecord) {
                    //红包记录
                    handleHasRewardChance(rewardInfo)
                    return
                }
                processTryResult(rewardInfo)
                mIsTrying = false
            }else{
                Logger.d(TAG, "handleTryResult no hasRewardOpenChance")
                mIsTrying = false
                if(rewardInfo.rewardType == RewardUtils.REWARD_TYPE_APP) {
                    mRewardMainHandler.postNoRewardChance(rewardInfo, 0)
                }else {
                    TryResponseListenerManager.notifyOnTryResponseChanged(rewardInfo)
                }
            }
        }
        mIsTrying = false
    }

    private fun processTryResult(rewardInfo: RewardUtils.RewardInfo){
        when (rewardInfo.rewardType) {
            RewardUtils.REWARD_TYPE_APP -> {
                //TODO gzw 做队列缓存处理
                handleHasRewardChance(rewardInfo)
            }
            RewardUtils.REWARD_TYPE_OPEN -> {
                TryResponseListenerManager.notifyOnTryResponseChanged(rewardInfo)
            }
        }
    }

    fun handleTryTimeout(rewardInfo: RewardUtils.RewardInfo?) {
        Logger.d(TAG,"handleTryTimeout")

        mIsTrying = false

        if(REWARD_DEBUG){
            rewardInfo?.tryResponse = RewardTryResponse()
            rewardInfo?.tryResponse?.uniqueId = rewardInfo?.apullAdItem?.uniqueId
            FakeRewardData.fakeTryResponse0(rewardInfo?.tryResponse)
        }

        rewardInfo?.apply {
            when (rewardInfo.rewardType) {
                RewardUtils.REWARD_TYPE_APP -> {
                    Logger.d(TAG,"handleTryTimeout appType")
                     handleNoRewardChance(rewardInfo)
                }
                RewardUtils.REWARD_TYPE_OPEN ->{
                    Logger.d(TAG,"handleTryTimeout OpenType")
                    mContext.toast(mContext.getString(R.string.hongbao_tip_try_again))
                    TryResponseListenerManager.notifyOnTryResponseChanged(null)
                }
                RewardUtils.REWARD_TYPE_OPEN_DEEP_LINK ->{
                    Logger.d(TAG,"handleTryTimeout OpenDeepLinkType")
                }
            }
        }
    }

    fun startRewardCommit(rewardInfo: RewardUtils.RewardInfo?) {
        if (rewardInfo == null) {
            Logger.d(TAG,"startRewardCommit rewardInfo empty")
            handleNoRewardChance(rewardInfo)
            return
        }

        rewardInfo.apply {
            /**
             * 红包记录
             */
            if(mDialogFromRecord){
                Logger.d(TAG,"startRewardCommit from record")
                if(!popupLoginDialog()) {
                    if(rewardInfo.isHourOpenType){
                        RewardCmdHandle.openAllTypeApp(mContext, rewardInfo.apullTemplate)
                    }
                    openRewardPackage(rewardInfo)
                }
                return
            }

            if (rewardType == RewardUtils.REWARD_TYPE_OPEN_DEEP_LINK ||
                    rewardType == RewardUtils.REWARD_TYPE_OPEN) {
                Logger.d(TAG,"startRewardCommit openType or openDeepLinkType")
                if(!popupLoginDialog()) {
                    openRewardPackage(rewardInfo)
                }
            } else if (rewardType == RewardUtils.REWARD_TYPE_APP) {
                Logger.d(TAG,"startRewardCommit appType")
                openDownloadTypeApp(rewardInfo)
            }
        }
    }

    private fun openDownloadTypeApp(rewardInfo: RewardUtils.RewardInfo) {
        if(rewardInfo.isHourOpenType){
            //整点红包打开类
            if(!popupLoginDialog()) {
                RewardCmdHandle.openAllTypeApp(mContext, rewardInfo.apullTemplate)
                openRewardPackage(rewardInfo)
            }
            return
        }

        if(rewardInfo.mPlayTime < RewardUtils.TASTE_APP_TIME){
            /**
             * 读取顶层应用权限
             */
            if(!RewardAuthGuideDialog.isPermissionOK(mContext,AuthConst.AUTH_CODE_USAGE_ACCESS)) {
                Logger.d(TAG,"top App Permission fail")
                popupAuthGuideDialog(mContext.getString(R.string.apullsdk_hongbao_auth_usage_access_24), AuthConst.AUTH_CODE_USAGE_ACCESS)
                return
            }

            Logger.d(TAG,"top App Permission OK")
            RewardRecordManager.setLastRewardUniqueId(mContext,rewardInfo.apullAdItem?.uniqueId)
            val flag =  RewardCmdHandle.openAllTypeApp(mContext,rewardInfo.apullTemplate)
            if(DEBUG){
                if(flag){
                    Logger.d(TAG,"openAllTypeApp : success")
                }else{
                    Logger.d(TAG,"openAllTypeApp : fail")
                }
            }
            /**
             * 打开不了可能是因为关联启动，尝试引导下权限
             */
            if(!flag){
                if(!RewardAuthGuideDialog.isPermissionOK(mContext,AuthConst.AUTH_CODE_SECONDARY_LAUNCH)
                      && !RewardRecordManager.getSecondLaunchShowFlag(mContext)){
                    Logger.d(TAG,"secondary launch PermissionFail")
                    popupAuthGuideDialog(mContext.getString(R.string.apullsdk_hongbao_auth_secondary_launch_83),AuthConst.AUTH_CODE_SECONDARY_LAUNCH)
                    RewardRecordManager.setSecondLaunchShowFlag(mContext,true)
                }else{
                    mContext.toast(mContext.getString(R.string.hongbao_open_app_fail))
                }
            }
        }else{
            Logger.d(TAG,"openDownloadTypeApp  openRewardPackage")
            //先体验15秒再尝试打开红包
            if(!popupLoginDialog()) {
                openRewardPackage(rewardInfo)
            }
        }
    }

    private fun openRewardPackage(rewardInfo: RewardUtils.RewardInfo) {
        Logger.d(TAG,"openRewardPackage")
        handleRewardCommit(rewardInfo)
    }

    private fun handleRewardCommit(rewardInfo: RewardUtils.RewardInfo) {
        Logger.d(TAG,"handleRewardCommit")

        refreshLoginInfo()
        rewardInfo.qid = mUserInfoBundle?.getString(LoginInterface.KEY_LOGININFO_QID)

        ApullRewardManager.getInstance().query(mContext, rewardInfo,
                rewardInfo.qid, mUserInfoBundle?.getString(LoginInterface.KEY_LOGININFO_Q),
                mUserInfoBundle?.getString(LoginInterface.KEY_LOGININFO_T), object : ApullRewardManager.Listener {

            override fun onCommitResponse(response: RewardCommitResponse?) {
                Logger.d(TAG,"handleRewardCommit onCommitResponse")
                mRewardMainHandler.postRewardCommitSuccess(response,rewardInfo)
            }

            override fun onTryResponse(response: RewardTryResponse?) {
            }
        })

        mRewardMainHandler.postRewardCommitTimeout(rewardInfo)
        if(rewardInfo.rewardType == RewardUtils.REWARD_TYPE_APP || rewardInfo.rewardType == RewardUtils.REWARD_TYPE_OPEN_DEEP_LINK) {
            mRewardMainHandler.postRewardToastSuccess()
        }
    }

    fun  handleCommitTimeout(rewardInfo: RewardUtils.RewardInfo?){
        Logger.d(TAG,"handleCommitTimeout")
        handleNoRewardChance(rewardInfo,TIMEOUT, rewardInfo?.rewardType ?: RewardUtils.REWARD_TYPE_APP)
    }

    @SuppressLint("StringFormatMatches")
    fun handleCommitResult(rewardInfo: RewardUtils.RewardInfo?) {
        Logger.d(TAG,"handleCommitResult")

        if (REWARD_DEBUG) {
            if(rewardInfo?.commitResponse == null){
                rewardInfo?.commitResponse = RewardCommitResponse()
            }
            FakeRewardData.fakeCommitResponse0(rewardInfo?.commitResponse)
        }

        if (rewardInfo?.commitResponse == null) {
            Logger.d(TAG,"handleCommitResult rewardInfo?.commitResponse empty")
            handleNoRewardChance(rewardInfo, TIMEOUT,rewardInfo?.rewardType ?: RewardUtils.REWARD_TYPE_APP)
            return
        }

        tryCatch {
            Logger.d(TAG, "handleCommitResult: errno:${rewardInfo.commitResponse.errno} ," +
                    "transId:${rewardInfo.commitResponse.transId}   " +
                    "amount:${rewardInfo.commitResponse.amount}  " +
                    "bonus: ${rewardInfo.commitResponse.bonus}  " +
                    "uniqueid: ${rewardInfo.commitResponse.uniqueId} " )
        }

        rewardInfo.commitResponse.apply {
            val cacheInfo = mRewardViewModel.getRewardInfo(rewardInfo.apullAdItem?.uniqueId)
            cacheInfo?.let {
                cacheInfo.commitResponse = this
            }
            if(!mDialogFromRecord) {
                mView?.refreshTryResultStatus(rewardInfo)
            }
        }.apply {
            takeIf {
                errno == 0
            }?.apply {
                // 保存抢到红包的总金额用于分享
                Logger.d(TAG,"handleCommitResult showSuccessDialog")

                RewardUtils.addMoney(mContext, amount)
                //红包记录
                mRewardRecordManager.saveCommitRecord(rewardInfo)
                mView?.dismissRewardDownloadDialog()
                mRewardMainHandler.postRewardToastSuccessHasMoney(amount)
                val shared = rewardInfo.tryResponse?.share ?: 0
                mView?.showRewardResultDialog(rewardInfo, true,shared > 0)
                return
            }?:apply {
                Logger.d(TAG,"handleCommitResult showFailDialog")
                mView?.dismissRewardDownloadDialog()
                val shared = rewardInfo.tryResponse?.share ?: 0
                mView?.showRewardResultDialog(rewardInfo, false,shared > 0)
            }
        }
    }

    fun handleToastSuccess() {
        mContext.toast(mContext.getString(R.string.hongbao_tip_goback))
    }

    @SuppressLint("StringFormatMatches")
    fun handleToastSuccessHasMoney(amount :Int){
        mContext.toast(mContext.getString(R.string.hongbao_tip_has_money, amount / 100.0))
    }

    /**
     * deepLink类型红包
     */
    fun handleDeepLinkResult(rewardInfo: RewardUtils.RewardInfo?){
        rewardInfo?.apply {
            tryCatch {
                if(isDeepLinkRewardType(rewardInfo)
                        && rewardInfo.mPlayTime >= RewardUtils.OPEN_DEEPLINK_TASTE_APP_TIME){
                    Logger.d(TAG,"handleDeepLinkResult back end time ="+System.currentTimeMillis())
                    if(rewardInfo.hasRewardOpenChance()){
                        val apullItemWrapper = rewardInfo.apullAdItem
                        if(apullItemWrapper.isOpenDeepLink()
                             || apullItemWrapper.isDownloadDeepLink()){
                            handleHasRewardChance(rewardInfo)
                        }else{
                            Logger.d(TAG,"not open deepLink or is not deepLink Type")
                        }

                    }else{
                        Logger.d(TAG,"not open deepLink or server no chance")
                    }
                }else{
                    Logger.d(TAG,"not open deepLink,or other rewardType")
                }
            }

        }
    }

    fun onBackPressedDownDialog(rewardInfo: RewardUtils.RewardInfo?) {
          Logger.d(TAG,"onBackPressedDownDialog")
          mIsDialogShow = false
          if(!mDialogFromRecord) {
              mView?.refreshTryResultStatus(rewardInfo)
          }
          mDialogFromRecord = false
          RewardRecordManager.setLastRewardUniqueId(mContext,"")
    }

    private fun popupLoginDialog() :Boolean {
        tryCatch {
            refreshLoginInfo()
            val shouldLogin = mUserInfoBundle == null
            if(shouldLogin) {
                Logger.d(TAG,"popupLoginDialog need login")
                mView?.popupLoginDialog()
                return true
            }
        }
        return false
    }

    private fun popupAuthGuideDialog(desc:String,authCode :Int){
        tryCatch {
            if(!RewardAuthGuideDialog.isPermissionOK(mContext,authCode)){
                Logger.d(TAG,"popupAuthGuideDialog authCode=$authCode desc=$desc  fail")
                mView?.popupAuthGuideDialog(desc,authCode)
                if(authCode == AuthConst.AUTH_CODE_SECONDARY_LAUNCH){
                    RewardRecordManager.setSecondLaunchShowFlag(mContext,true)
                }
                return
            }
        }

    }

    private fun refreshLoginInfo() {
        tryCatch {
            mUserInfoBundle = LoginProxy.getLoginInfo(mContext)
        }
    }

    /**
     * 不可以拆红包，很遗憾，超时或者没有机会
     */
    fun handleNoRewardChance(rewardInfo: RewardUtils.RewardInfo?, status:Int = DONT_HAS_CHANCE,rewardType:Int = RewardUtils.REWARD_TYPE_APP) {
        if(status == TIMEOUT){
            rewardInfo?.hasTryAndTimeOut = true
            Logger.d(TAG,"handleNoRewardChance timeOut status=$status")
            mView?.showFailResultDownloadDialog(rewardInfo, status,rewardType)
            return
        }

        mContext.toast(mContext.getString(R.string.hongbao_tip_try_again))

        val shared = RewardUtils.getSharedInfo(mContext)
        val chance = rewardInfo?.tryResponse?.chances ?: 0
        val tryShare = rewardInfo?.tryResponse?.share ?: 0
        Logger.d(TAG,"handleNoRewardChance  shared=$shared   chance = $chance  tryShare=$tryShare status = $status")

        var statused: Int
        statused = if(status == DONT_HAS_CHANCE) {
            if (chance <= 0 && tryShare > 0 && shared <= 0) {
                SHARE_MORE_CHANCE
            } else {
                DONT_HAS_CHANCE
            }
        }else{
            status
        }
        Logger.d(TAG,"handleNoRewardChance statused=$statused")

        mView?.showFailResultDownloadDialog(rewardInfo, statused,rewardType)

    }

    /**
     * 可以拆红包
     */
    private fun handleHasRewardChance(rewardInfo: RewardUtils.RewardInfo?){
        rewardInfo?.apply {
            mView?.showChanceResultDownloadDialog(rewardInfo)
        }
    }

    /**
     * 红包记录列表
     */
    fun showRewardRecord() {
        mRewardRecordManager.showRecord(null)
    }

    /**
     * 红包记录："领红包"
     */
    override fun handleRewardRecordOpen(rewardInfo: RewardUtils.RewardInfo?) {
         rewardInfo?.apply {
             Logger.d(TAG,"handleRewardRecordOpen")
             mDialogFromRecord = true
             rewardInfo.hasTryAndTimeOut = false
             handleTryResult(this)
         }
    }

    /**
     * 统计当前下载类红包在栈顶时长
     */
    fun computeAppActiveTime(packageName : String?){
        Logger.d(TAG,"computeAppActiveTime packageName = $packageName")

        val mLastUniqueId = RewardRecordManager.getLastRewardUniqueId(mContext)
        if(packageName.isNullOrEmpty() || mLastUniqueId.isNullOrEmpty()){
            Logger.d(TAG,"computeAppActiveTime uniqueId empty")
            return
        }
        Logger.d(TAG,"computeAppActiveTime mLastUniqueId = $mLastUniqueId")

        var mRewardInfo = mRewardViewModel.getRewardInfo(mLastUniqueId)
        if((mRewardInfo?.hasTryAndTimeOut == true) || (mRewardInfo?.rewardType == RewardUtils.REWARD_TYPE_OPEN)
               || (mRewardInfo?.rewardType == RewardUtils.REWARD_TYPE_APP
                        && mRewardInfo.apullAdItem?.getDownloadStatus() != ApullConst.STATUS_TYPE_INSTALL_FINISHED
                        && !mRewardInfo.hasRewardOpenChance())){
            Logger.d(TAG,"computeAppActiveTime not conditional")
            return
        }

        mRewardInfo?.apply {

            val mCachePackageName = mRewardInfo.apullAdItem.getRewardPackageName()
            if(mCachePackageName.isNullOrEmpty()){
                Logger.d(TAG,"computeAppActiveTime ad packageName empty ")
                return
            }
            Logger.d(TAG,"computeAppActiveTime mCachePackageName= $mCachePackageName")

            if(mLastPackageName?.isEmpty() == false ){

                if(mLastPackageName == mCachePackageName
                    && mLastPackageName != packageName){

                    Logger.d(TAG,"computeAppActiveTime end mLastPackageName= $mLastPackageName")
                    val endTime = System.currentTimeMillis()
                    Logger.d(TAG,"computeAppActiveTime endTime= $endTime")

                    mRewardInfo.mEndTime = endTime
                    val mUsageTime = mRewardInfo.appActiveTime
                    Logger.d(TAG,"computeAppActiveTime durationTime= $mUsageTime")

                    if(mRewardInfo.rewardType == RewardUtils.REWARD_TYPE_APP){
                        // 更新提示文案,文案抖动
                        if(mRewardInfo.hasRewardOpenChance()) {
                            handleHasRewardChance(mRewardInfo)
                        }
                    }
                    mRewardRecordManager.saveCommitRecord(mRewardInfo)

                    if(!mRewardInfo.mRewardTypeToast && mRewardInfo.hasRewardOpenChance()){
                        /**
                         * deeplink打开类或者deeplink下载类红包且应用已安装时，需要使用3秒，弹toast返回后3秒如果有领红包机会则弹窗
                         * 下载类时需要体验15秒才能领红包
                         */
                        if((isDeepLinkRewardType(mRewardInfo) && mRewardInfo.appActiveTime >= RewardUtils.OPEN_DEEPLINK_TASTE_APP_TIME
                                        || mRewardInfo.rewardType == RewardUtils.REWARD_TYPE_APP
                                                && mRewardInfo.appActiveTime >= RewardUtils.TASTE_APP_TIME)){
                                    mContext.toast("红包来了~")
                                    mRewardInfo.mRewardTypeToast = true
                        }
                    }
                    mRewardInfo.mStartTime = mRewardInfo.mEndTime
                    mLastPackageName = ""
                }
            }else{
                if(packageName == mCachePackageName){
                    mLastPackageName = packageName
                    Logger.d(TAG,"computeAppActiveTime start mLastPackageName= $mLastPackageName")

                    val startTime = System.currentTimeMillis()
                    mRewardInfo.mStartTime = startTime
                    Logger.d(TAG,"computeAppActiveTime startTime= $startTime")

                    mRewardInfo.mEndTime = mRewardInfo.mStartTime
                }
            }
        }
    }

    /**
     * 打开类从webView返回，是否有领红包机会
     */
    fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?){
        if (resultCode == RewardConstant.REWARD_OPEN_TYPE_RESULT_CODE &&
                requestCode == RewardConstant.REWARD_OPEN_TYPE_REQUEST_CODE) {
           data?.apply {
                val canOpen = getBooleanExtra(RewardConstant.REWARD_CAN_UNFOLDER_OPEN_REWARD, false)
                val uniqueId = getStringExtra(RewardConstant.REWARD_AD_UNIQUE_ID)
                if (!uniqueId.isNullOrEmpty()) {
                    val rewardInfo = mRewardViewModel.getRewardInfo(uniqueId) ?: return
                    val tryResultCanOpen =rewardInfo.apullAdItem!= null && rewardInfo.tryResponse?.result == 1 &&
                            !TextUtils.isEmpty(rewardInfo.tryResponse.uniqueId) && canOpen
                    if (tryResultCanOpen) {
                        Logger.d(TAG, "onActivityResult Open type rewardType onActivityResult dialogShowReward")
                        handleHasRewardChance(rewardInfo)
                    }
                }
            }
        }
    }

    /**
     * 打开类红包通知WebView
     */
    fun notifyTryResponse(uniqueId:String?){
        if(uniqueId.isNullOrEmpty().not()){
            val rewardInfo = mRewardViewModel.getRewardInfo(uniqueId)
            rewardInfo?.apply {
                if (rewardType == RewardUtils.REWARD_TYPE_OPEN) {
                    if (hasRewardOpenChance()) {
                        TryResponseListenerManager.notifyOnTryResponseChanged(this)
                    }
                }
            }
        }
    }

    fun startCheckRewardChanceOnResume(){
        val mUniqueId = RewardRecordManager.getLastRewardUniqueId(mContext)
        Logger.d(TAG,"handleOnResumeRewardChance")
        if(!mUniqueId.isNullOrEmpty()){
            Logger.d(TAG,"handleOnResumeRewardChance uniqueId=$mUniqueId")
            val rewardInfo = mRewardViewModel.getRewardInfo(mUniqueId)
            rewardInfo?.apply {
                if(isDeepLinkRewardType(rewardInfo) ){
                    if(rewardInfo.hasRewardOpenChance()) {
                        if(!hasTryAndTimeOut) {
                            mRewardMainHandler.postRewardDeepLinkType(rewardInfo)
                        }
                    }else{
                        mContext.toast(mContext.getString(R.string.hongbao_tip_try_again))
                    }
                }else if(rewardInfo.rewardType == RewardUtils.REWARD_TYPE_APP){
                    if(rewardInfo.hasRewardOpenChance() && !rewardInfo.hasTryAndTimeOut){
                        handleHasRewardChance(rewardInfo)
                    }
                }
            }
        }

    }

    private fun isDeepLinkRewardType(rewardInfo: RewardUtils.RewardInfo?): Boolean {
        return rewardInfo?.rewardType == RewardUtils.REWARD_TYPE_OPEN_DEEP_LINK &&
                rewardInfo.apullAdItem?.getProtocolType() == ApullItemWrapper.MV
    }

    fun  backKeyDown():Boolean{
        if(canShowTwiceDialog()){
           val twiceTemplates = mRewardViewModel.getTwiceTemplates()
            twiceTemplates?.apply {
                if(size > 0){
                    val pairs = mutableListOf<Pair<ApullTemplateBase?, ApullContainerBase?>>()
                    filter { it !=null }.forEach { template ->
                        val container = buildSingleRewardContainer(this@RewardPresenter.mContext, template)
                        container?.let {
                            val pair = Pair(template, it)
                            mRewardViewModel.cacheRewardTemplate(template)
                            pairs.add(pair)
                        }
                    }
                    if (pairs.isNotEmpty()) {
                        mTwiceRewardContainer = RewardContainer(this@RewardPresenter.mContext, pairs,1)
                        val now = System.currentTimeMillis()
                        RewardRecordManager.setTwiceDialogLastShowTime(mContext,now)
                        val mTwiceDialog = RewardNewTwiceDialog(mContext,mTwiceRewardContainer)
                        mTwiceDialog.show()
                        return true
                    }
                }
            }
        }
        return false
    }

    fun onDestroy() {
        RewardRecordManager.setSecondLaunchShowFlag(mContext, false)
        RewardRecordManager.setLastRewardUniqueId(mContext,"")
    }

    fun getHourTemplate(scene:Int,mSubScene:Int):ApullTemplateBase?{
        return mRewardViewModel.getHourTemplate(scene,mSubScene)
    }

    fun canShowTwiceDialog() :Boolean{
        val now = System.currentTimeMillis()
        val lastShowTime = RewardRecordManager.getTwiceDialogLastShowTime(mContext)
        return Math.abs(now -lastShowTime) > 24 * 60 * 60 * 1000
    }
}

