package com.qihoo360.mobilesafe.reward.ui.page

import android.annotation.SuppressLint
import android.annotation.TargetApi
import android.content.Context
import android.content.Intent
import android.content.pm.PackageManager
import android.graphics.Color
import android.net.Uri
import android.os.Build
import android.os.Bundle
import android.os.Handler
import android.os.Message
import android.text.TextUtils
import android.view.KeyEvent
import android.view.View
import android.view.animation.AlphaAnimation
import android.webkit.DownloadListener
import android.webkit.JavascriptInterface
import android.webkit.WebView
import android.webkit.WebViewClient
import android.widget.AdapterView.OnItemClickListener
import android.widget.ProgressBar


import com.qihoo360.apullsdk.utils.WebViewResourceHelper
import com.qihoo360.framework.base.IKillable
import com.qihoo360.mobilesafe.extension.setVisible
import com.qihoo360.mobilesafe.extension.toast
import com.qihoo360.mobilesafe.extension.tryCatch

import com.qihoo360.mobilesafe.reward.R
import com.qihoo360.mobilesafe.reward.RewardConfigHelper
import com.qihoo360.mobilesafe.reward.data.RewardUtils

import com.qihoo360.mobilesafe.ui.common.other.CommonWebChromeClientEx

import org.json.JSONArray

import java.lang.ref.WeakReference
import java.util.HashSet

import com.qihoo360.mobilesafe.reward.RewardConstant.Companion.ACTION_REWARD_AD_NEWS_H5_CREATE
import com.qihoo360.mobilesafe.reward.RewardConstant.Companion.EXTRA_KEY_TITLE
import com.qihoo360.mobilesafe.reward.RewardConstant.Companion.EXTRA_KEY_URL
import com.qihoo360.mobilesafe.reward.RewardConstant.Companion.REWARD_AD_UNIQUE_ID
import com.qihoo360.mobilesafe.reward.RewardConstant.Companion.REWARD_CAN_UNFOLDER_OPEN_REWARD
import com.qihoo360.mobilesafe.reward.RewardConstant.Companion.REWARD_OPEN_TYPE_RESULT_CODE
import com.qihoo360.mobilesafe.reward.base.BaseActivity
import com.qihoo360.mobilesafe.reward.utils.OnTryResponseListener
import com.qihoo360.mobilesafe.reward.utils.TryResponseListenerManager
import com.qihoo360.mobilesafe.reward.utils.UrlUtils
import com.qihoo360.mobilesafe.support.log.Logger
import com.qihoo360.mobilesafe.support.log.Logger.*
import kotlinx.android.synthetic.main.reward_webview.*

class RaffleWebViewActivity : BaseActivity(), IKillable, OnTryResponseListener {


    private var mUrl: String? = null

    private var mTitle: String? = null

    private val mProductAdIds = HashSet<String>()

    private var mRewardInfo: RewardUtils.RewardInfo? = null

    private var mUrlHostType = ""

    private var mCanOpenReward = false

    private var mInitId = ""

    private val mClickTime = 3

    private var mStartTime: Long = 0

    private var mHandler = NewsHandler(this)

    private var uniqueId: String? = null
    private var mDeepLinkTimes = 0

    private val mRedPacketUrlList = HashSet<String>()

    private var mRedPacketInit = false
    /**
     * 广告聚合类
     */
    private var mHasRewardChance = 3

    private var mRedPacketClickTimes = 0

    private val urlHostType: String
        get() {
            tryCatch({
                Logger.d(TAG, "getUrlHostType exception")
                Logger.handleException(it)
            }) {
                if (mUrl.isNullOrEmpty()) {
                    return ""
                }
                Logger.d(TAG, "getUrlHostType1 mUrl = $mUrl")
                val filterUrls = RewardConfigHelper.getUrlTypes()
                val mDecodeUrl: String? = java.net.URLDecoder.decode(mUrl, "utf-8")
                mDecodeUrl?.apply {
                    Logger.d(TAG, "getUrlHostType2 mUrl = $mDecodeUrl")
                    val iterator = filterUrls.iterator()
                    while (iterator.hasNext()) {
                        val entry = iterator.next()
                        val url = entry.key
                        val type = entry.value

                        if (mDecodeUrl.contains(url)) {
                            return when {
                                TAOBAO == type -> TAOBAO
                                REDPACKETS == type -> REDPACKETS
                                else -> FORM
                            }
                        }
                    }
                }
            }
            return FORM
        }

    /**
     * 广告聚合类并且有抢红包机会
     * @return
     */
    val isRedPacketAndHasChance: Boolean
        get() = REDPACKETS == mUrlHostType && hasRedPacketChance()

    @SuppressLint("NewApi")
    override fun onCreate(savedInstanceState: Bundle?) {
        setUseStatusBarTranslucent(false)
        super.onCreate(savedInstanceState)
        tryCatch ({
            toast(getString(R.string.apull_webview_error))
            finish()
            return
        }){
            setContentView(R.layout.reward_webview)
            mRoot?.setBackgroundColor(resources.getColor(R.color.common_bg_white))
            initData()
            if (mUrl.isNullOrEmpty()) {
                finish()
                return
            }
            mTitleBar?.setBackgroundColor(Color.WHITE)
            mTitleBar?.setSettingImg(R.drawable.setting_button_image_detail)
            mTitleBar?.setBackImg(R.drawable.back_button_image_detail)
            if (!mTitle.isNullOrEmpty()) {
                mTitleBar?.setTitle(mTitle)
            }
            mTitleBar?.setBackImg(R.drawable.news_titlebar_close)
            mTitleBar?.setBackVisible(true)
            mTitleBar?.setSettingVisible(false)
            mTitleBar?.setOnBackListener { finish() }
            mWebView?.addJavascriptInterface(CmdJs(), "redpackets")
            val ws = mWebView?.settings
            ws?.javaScriptEnabled = true
            ws?.useWideViewPort = true
            ws?.domStorageEnabled = true
            mWebView?.isVerticalScrollBarEnabled = false
            mWebView?.setWebViewClient(object : WebViewClient() {

                override fun onPageFinished(view: WebView?, url: String) {
                    super.onPageFinished(view, url)
                    this@RaffleWebViewActivity.onPageFinished(view, url)
                }

                override fun onPageStarted(view: WebView?, url: String, favicon: android.graphics.Bitmap?) {
                    super.onPageStarted(view, url, favicon)
                }

                override fun onReceivedError(view: WebView?, errorCode: Int, description: String, failingUrl: String) {
                    super.onReceivedError(view, errorCode, description, failingUrl)
                }

                @TargetApi(Build.VERSION_CODES.DONUT)
                override fun shouldOverrideUrlLoading(view: WebView?, url: String): Boolean {
                    tryCatch {
                        if (url?.startsWith("http") || url.startsWith("https")) {
                            // 针对网络请求
                            if (REDPACKETS == mUrlHostType) {
                                Logger.d(TAG, "$REDPACKETS http or https url = $url")
                                addRedPacketClickTimes(url)
                            }
                            return super.shouldOverrideUrlLoading(view, url)
                        } else if (url.startsWith("tel:") || url.startsWith("sms:")) {
                            // 针对电话和短信
                            val intent = Intent(Intent.ACTION_VIEW, Uri.parse(url))
                            startActivity(intent)
                            return true
                        } else {
                            // 针对deeplink
                            Logger.d(TAG, "shouldOverrideUrl deeplink :$mUrl")
                            val deepLinkIntent = Intent.parseUri(url, 0)
                            deepLinkIntent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK)
                            deepLinkIntent.action = "android.intent.action.VIEW"
                            val res = this@RaffleWebViewActivity.packageManager
                                    .queryIntentActivities(deepLinkIntent, PackageManager.MATCH_DEFAULT_ONLY)
                            if (res != null && res.size > 0) {

                                if (TAOBAO == mUrlHostType) {
                                    if (mDeepLinkTimes == 0) {
                                        mDeepLinkTimes = 1
                                        return true
                                    }

                                    if (mRewardInfo == null) {
                                        this@RaffleWebViewActivity.startActivity(deepLinkIntent)
                                        return true
                                    }
                                    val idSize = mProductAdIds.size

                                    return when {
                                        idSize <= 0 -> {
                                            this@RaffleWebViewActivity.startActivity(deepLinkIntent)
                                            true
                                        }
                                        idSize <= mClickTime -> true
                                        else -> {
                                            this@RaffleWebViewActivity.startActivity(deepLinkIntent)
                                            true
                                        }
                                    }
                                } else if (REDPACKETS.contains(mUrlHostType)) {

                                    if (!hasRedPacketChance()) {
                                        Logger.d(TAG, "$REDPACKETS deeplink hasRedPacketChance $url")
                                        this@RaffleWebViewActivity.startActivity(deepLinkIntent)
                                        return true
                                    }

                                    Logger.d(TAG, "$REDPACKETS deeplink = $url")
                                    addRedPacketClickTimes(url)
                                    this@RaffleWebViewActivity.startActivity(deepLinkIntent)
                                    return true
                                    // }
                                }
                                this@RaffleWebViewActivity.startActivity(deepLinkIntent)
                                return true

                            }
                        }
                    }

                    return true
                }

            })

            mWebView?.setWebChromeClient(object : CommonWebChromeClientEx() {
                override fun onProgressChanged(view: WebView, progress: Int) {
                    super.onProgressChanged(view, progress)
                    if (progress < 100 && mProgressBar?.visibility == ProgressBar.GONE) {
                        mProgressBar?.visibility = ProgressBar.VISIBLE
                    }
                    mProgressBar?.progress = progress
                    if (progress == 100) {
                        mProgressBar?.progress = 100
                        val anim = AlphaAnimation(1f, 0f)
                        anim.duration = 600
                        anim.fillAfter = true
                        mProgressBar?.startAnimation(anim)
                    }
                }

                override fun onReceivedTitle(view: WebView, title: String) {
                    super.onReceivedTitle(view, title)
                    if (!TextUtils.isEmpty(title)) {
                        mTitleBar?.titleView?.visibility = View.VISIBLE
                        mTitleBar?.titleView?.setTextColor(resources.getColor(R.color.common_font_color_10))
                        mTitleBar?.setTitle(title)
                    }
                }
            })
            mWebView?.setDownloadListener(NewsWebViewDownLoadListener())
            if (!mUrl.isNullOrEmpty()) {
                mWebView?.loadUrl(mUrl)
            }
            WebViewResourceHelper.addChromeResourceIfNeeded(this)

            mTipsClose?.setOnClickListener {
                mTipsLayout?.setVisible(false)
            }
        }

    }

    override fun onDestroy() {
        super.onDestroy()
        tryCatch {
            mWebView?.destroy()
            TryResponseListenerManager.unRegister(uniqueId,this)
        }

    }

    override fun onKeyDown(keyCode: Int, event: KeyEvent): Boolean {
        if (keyCode == KeyEvent.KEYCODE_BACK && mWebView?.canGoBack() == true) {
            mWebView.goBack()
            return true
        }
        return super.onKeyDown(keyCode, event)
    }

    override fun onBackPressed() {
        if (mWebView?.canGoBack() == true) {
            mWebView.goBack()
            return
        }
        super.onBackPressed()
    }

    override fun isKillable(): Boolean {
        return false
    }

    private fun initData() {
       tryCatch {
           val intent = intent
           intent?.apply {
               mTitle = intent.getStringExtra(EXTRA_KEY_TITLE)

               initHongBaoData(intent)
           }
       }
    }

    private fun initHongBaoData(intent: Intent) {
        mUrl = intent.getStringExtra(EXTRA_KEY_URL)
        uniqueId = intent.getStringExtra(REWARD_AD_UNIQUE_ID)
        if (TextUtils.isEmpty(mUrl)  || TextUtils.isEmpty(uniqueId)) {
            finish()
            return
        }

        mUrlHostType = urlHostType
        when {
            TAOBAO == mUrlHostType -> {
                Logger.d(TAG, "taobao url")
                mInitId = UrlUtils.getTaoBaoUriProductId(mUrl)
                mTipsView?.text = getText(R.string.apullsdk_hongbao_toast_tips_one)
            }
            REDPACKETS == mUrlHostType -> {
                Logger.d(TAG, "redpackets url")
                mTipsView?.visibility = View.GONE
            }
            FORM == mUrlHostType -> {
                Logger.d(TAG, "form url")
                mStartTime = System.currentTimeMillis()
                Logger.d(TAG, "onCreate time = $mStartTime")
                mTipsView?.text = getText(R.string.apullsdk_hongbao_toast_tips_two)
            }
        }

        TryResponseListenerManager.register(uniqueId,this)

        val intent1 = Intent()
        intent1.action = ACTION_REWARD_AD_NEWS_H5_CREATE
        intent1.putExtra(REWARD_AD_UNIQUE_ID, uniqueId)
        sendBroadcast(intent1)
    }


    private inner class NewsWebViewDownLoadListener : DownloadListener {

        override fun onDownloadStart(url: String, userAgent: String,
                                     contentDisposition: String, mimetype: String, contentLength: Long) {
            /**
             * 广告聚合类下载类次数增加
             */
            val uri = Uri.parse(url)
            if (isRedPacketAndHasChance) {
                Logger.d(TAG, "$REDPACKETS download url = $url")
                addRedPacketClickTimes(url)
            }
            val intent = Intent(Intent.ACTION_VIEW, uri)
            intent.addCategory(Intent.CATEGORY_BROWSABLE)
            startActivity(intent)

        }
    }

    private fun onPageFinished(view: WebView?, url: String) {
        /**
         * 支付宝判断逻辑
         */
        tryCatch{
            if (TAOBAO == mUrlHostType) {
                Logger.d(TAG, "onPageFinishe taobao url = $url")
                val productId = UrlUtils.getTaoBaoUriProductId(url)
                if (TextUtils.isEmpty(productId) || TextUtils.equals(productId, mInitId)) {
                    return
                }

                if (!mProductAdIds.contains(productId) && mRewardInfo != null) {
                    mProductAdIds.add(productId)
                    val clickSize = mProductAdIds.size
                    if (clickSize in 1..mClickTime) {
                        val tips = getString(R.string.apullsdk_hongbao_has_open_ad_tips, clickSize)
                        if (isAvailable(this, "com.taobao.taobao")) {
                            showToast(SHOW_REWARD_TOAST, tips, 0)
                        } else {
                            showToast(SHOW_REWARD_TOAST, tips, TOAST_DELAY_TIME)
                        }
                    } else if (clickSize > mClickTime) {
                        mCanOpenReward = true
                        val tips = getString(R.string.apullsdk_hongbao_come)
                        if (isAvailable(this, "com.taobao.taobao")) {
                            showToast(SHOW_REWARD_TOAST, tips, 0)
                        } else {
                            showToast(SHOW_REWARD_TOAST, tips, TOAST_DELAY_TIME)
                        }
                    }
                }
            } else if (REDPACKETS == mUrlHostType) {
                Logger.d(TAG, "$REDPACKETS http or http url =$url")
                addRedPacketClickTimes(url)
            } else if (FORM == mUrlHostType) {
            }
        }
    }
    private inner class CmdJs {

        @JavascriptInterface
        fun setJumpList(json: String) {

            tryCatch({
                Logger.d(TAG,it.message)
                Logger.handleException(it)
            }){
                Logger.d(TAG,"setJumpList start")
                if (mRedPacketInit)
                    return
                Logger.d(TAG,"setJumpList json=$json")

                val array = JSONArray(json)
                if (array.length() > 0) {
                    for (i in 0 until array.length()) {
                        val url = array.optString(i)
                        if (!TextUtils.isEmpty(url)) {
                            Logger.d(TAG, "REDPACKETS  js h5 url= $url")
                            mRedPacketUrlList.add(url)
                        }
                    }
                    Logger.d(TAG, REDPACKETS + " url size = " + mRedPacketUrlList.size)
                    if (mRedPacketUrlList.size > 3) {
                        mHasRewardChance = mHasRewardChance and FLAG2
                    } else {
                        showToast(SHOW_REWARD_TOAST, "很遗憾，没有抢到红包", 0)
                    }
                    mRedPacketInit = true
                }

            }
        }
    }

    override fun onTryResponseCallBack(info: RewardUtils.RewardInfo?) {
        Logger.d(TAG, "onTryResponseCallBack")
        if (info!= null && info != mRewardInfo) {
            Logger.d(TAG, "onTryResponseCallBack:$info")
            mRewardInfo = info

            if(mRewardInfo?.hasRewardOpenChance() == false){
                mRewardInfo = null
                return
            }
            if (REDPACKETS == mUrlHostType) {
                mHasRewardChance = mHasRewardChance and FLAG1
            }
            if (FORM == mUrlHostType) {
                val mCurrentTime = System.currentTimeMillis()
                showToast(SHOW_REWARD_TOAST, getString(R.string.apullsdk_hongbao_come), mCurrentTime + REMAIN_TIME - mStartTime)
            }
            if (FORM == mUrlHostType || TAOBAO == mUrlHostType) {
                hideOrShowGuideTips(true, 0)
                hideOrShowGuideTips(false, GUIDE_TIP_REMAIN_TIME)
            }
        }
    }

    override fun finish() {
        if(TextUtils.equals(mRewardInfo?.apullAdItem?.uniqueId,uniqueId)) {
            if (FORM == mUrlHostType) {
                val finishTime = System.currentTimeMillis()
                Logger.d(TAG, "finish time = $finishTime")

                //非淘宝页面需要等待30S
                mCanOpenReward = finishTime - mStartTime >= REMAIN_TIME
            }
            if (isRedPacketAndHasChance && mRedPacketClickTimes >= 3) {
                Logger.d(TAG, "$REDPACKETS can open reward ")
                mCanOpenReward = true
            }
            mHandler.removeMessages(SHOW_TIPS_SHOW_OR_HIDE)
            mHandler.removeMessages(SHOW_REWARD_TOAST)

            Logger.d(TAG, "can open hongbao: $mCanOpenReward")

            if (mCanOpenReward) {
                val intent = Intent()
                intent.putExtra(REWARD_CAN_UNFOLDER_OPEN_REWARD, true)
                intent.putExtra(REWARD_AD_UNIQUE_ID, uniqueId)
                setResult(REWARD_OPEN_TYPE_RESULT_CODE, intent)
            }
        }
        super.finish()
    }

    fun hideOrShowGuideTips(show: Boolean) {
        if (!show) {
            mTipsLayout?.setVisible(false)
        } else {
            mTipsLayout?.setVisible(true)
        }
    }

    private fun hideOrShowGuideTips(show: Boolean, delayTime: Long) {
        val message = Message.obtain()
        message.what = SHOW_TIPS_SHOW_OR_HIDE
        message.arg1 = if (show) 1 else 0
        mHandler.sendMessageDelayed(message, delayTime)
    }

    fun showToast(what: Int, desc: String, delayTime: Long) {
        val message = Message.obtain()
        message.what = what
        message.obj = desc
        mHandler.sendMessageDelayed(message, delayTime)
    }

    fun showToast(context: Context?, desc: String) {
        context?.apply {
            toast(desc)
        }
    }

    private class NewsHandler(outer: RaffleWebViewActivity) : Handler() {

        internal val outer: WeakReference<RaffleWebViewActivity> = WeakReference(outer)

        override fun handleMessage(msg: Message) {
            val outerObj = outer.get() ?: return

            when (msg.what) {
                SHOW_REWARD_TOAST -> {
                    val desc = msg.obj as String
                    outerObj.showToast(outerObj, desc)
                }
                SHOW_TIPS_SHOW_OR_HIDE -> outerObj.hideOrShowGuideTips(msg.arg1 == 1)
            }

        }

    }

    /**
     * 广告聚合类是否满足领红包条件,不满足则提示很遗憾
     * 1、有领红包机会
     * 2、mRedPacketUrlList.size() > 3
     */
    fun hasRedPacketChance(): Boolean {
        return mHasRewardChance == 0
    }

    private fun addRedPacketClickTimes(url: String?) {
        if (isRedPacketAndHasChance && mRedPacketUrlList.contains(url)) {
            if (url?.isNotEmpty() == true && !mProductAdIds.contains(url)) {
                mProductAdIds.add(url)
                mRedPacketClickTimes++
                Logger.d(TAG, "$REDPACKETS   clickTime=$mRedPacketClickTimes  url=$url")
                popRedPacketToast()
            } else {
                popRedPacketToast()
            }
        }
    }

    private fun popRedPacketToast() {
        if (mRedPacketClickTimes in 1..(mClickTime - 1)) {
            val tips = getString(R.string.apullsdk_hongbao_has_open_ad_tips_ad, mRedPacketClickTimes)
            showToast(SHOW_REWARD_TOAST, tips, 0)
        } else if (mRedPacketClickTimes >= mClickTime) {
            mCanOpenReward = true
            val tips = getString(R.string.apullsdk_hongbao_come)
            showToast(SHOW_REWARD_TOAST, tips, 0)
        }
    }

    companion object {
        private const val TAG = "RaffleWebViewActivity"
        private const val TAOBAO = "taobao"
        private const val REDPACKETS = "redpackets"
        private const val FORM = "FORM"
        private const val REMAIN_TIME = (30 * 1000).toLong()
        private const val GUIDE_TIP_REMAIN_TIME = (20 * 1000).toLong()
        private const val TOAST_DELAY_TIME = (3 * 1000).toLong()
        private const val FLAG1 = 2//try接口有机会
        private const val FLAG2 = 1//链接里有三个url
        private const val SHOW_REWARD_TOAST = 1//弹点击广告次数或红包来了
        private const val SHOW_TIPS_SHOW_OR_HIDE = 2//显示或隐藏悬浮窗

        private fun isAvailable(context: Context?, packageName: String): Boolean {
            if (context == null || TextUtils.isEmpty(packageName)) {
                return false
            }
            val packageManager = context.packageManager
            val pInfo = packageManager.getInstalledPackages(0)
            for (i in pInfo.indices) {
                if (pInfo[i].packageName.equals(packageName, ignoreCase = true)) {
                    return true
                }
            }
            return false
        }

    }

}
