package com.qihoo360.mobilesafe.reward.ui.page.dialog

import android.content.Context
import com.qihoo360.mobilesafe.authguide.service.AuthConst
import com.qihoo360.mobilesafe.authguide.service.AuthGuideServiceHelper
import com.qihoo360.mobilesafe.reward.R
import com.qihoo360.mobilesafe.support.log.Logger
import com.qihoo360.mobilesafe.ui.common.dialog.CommonDialog

class RewardAuthGuideDialog(context: Context) : CommonDialog(context) {

    constructor(context: Context, desc:String,authCode :Int, listener: Listener?):this(context){
        setTitle(R.string.tips_title)
        contentTextView.text = desc
        setBtnCancelText(R.string.cancel)
        setBtnOkText(R.string.apullsdk_hongbao_go_auth)
        setBtnCancelListener {
            dismiss()
            listener?.onBtnCancel()
        }
        setBtnOkListener {
            dismiss()
            listener?.onBtnOk(authCode)
        }
    }

    interface Listener {
        fun onBtnOk(authCode: Int)
        fun onBtnCancel()
    }


    companion object {
        /**
         * 判断权限是否开启
         */
        fun isPermissionOK(context: Context?, authCode: Int): Boolean {
            val status = AuthGuideServiceHelper.queryAuthStatus(context, authCode)
            Logger.d("RewardManager", "authCode = $authCode    status=$status")
            return status == AuthConst.AUTH_STATUS_MIGHT_ON || status == AuthConst.AUTH_STATUS_ON || status == AuthConst.AUTH_STATUS_ERROR || status == AuthConst.AUTH_STATUS_UNADAPTED
        }
    }

}
